package cn.com.qmth.examcloud.core.examwork.service;

import cn.com.qmth.examcloud.api.commons.enums.CURD;
import cn.com.qmth.examcloud.api.commons.exchange.PageInfo;
import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamEntity;
import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamIpLimitEntity;
import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamSpecialSettingsEntity;
import cn.com.qmth.examcloud.core.examwork.service.bean.ExamInfo;
import cn.com.qmth.examcloud.core.examwork.service.bean.ExamSpecialSettingsInfo;

import java.io.File;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年8月17日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface ExamService {

    /**
     * 保存考试
     *
     * @param examInfo
     * @return
     * @author WANGWEI
     */
    ExamEntity saveExam(ExamInfo examInfo, CURD es);

    /**
     * 保存考试机构设置
     *
     * @param examSpecialInfo
     * @return
     * @author WANGWEI
     */
    ExamSpecialSettingsEntity saveExamSpecialSettings(ExamSpecialSettingsInfo examSpecialInfo);

    /**
     * 查询考试机构属性
     *
     * @param examId
     * @param orgId
     * @param key
     * @return
     * @author WANGWEI
     */
    String getExamOrgProperty(Long examId, Long orgId, String key);

    /**
     * 查询考试学生属性
     *
     * @param examId
     * @param studentId
     * @param key
     * @return
     * @author WANGWEI
     */
    String getExamStudentProperty(Long examId, Long studentId, String key);

    /**
     * 导入学习中心设置
     *
     * @param examId
     * @param file
     * @return
     * @author WANGWEI
     */
    List<Map<String, Object>> importExamOrgSettings(Long examId, File file);

    /**
     * 查询考试属性
     *
     * @param examId
     * @param key
     * @return
     * @author WANGWEI
     */
    String getExamProperty(Long examId, String key);

    Map<Long, ExamEntity> getExamMapsByIds(Set<Long> examIds);

    PageInfo<ExamIpLimitEntity> pageIpLimited(Integer curPage, Integer pageSize, Long examId, Integer limitType, String ip);
}
